﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Interactivity;

namespace MasterDetailsViewDemo
{
    public class SelectionBehaviour : Behavior<SfDataGrid>
    {
        public object FirstDetailsViewSelectedItem
        {
            get { return (object)GetValue(FirstDetailsViewSelectedItemProperty); }
            set { SetValue(FirstDetailsViewSelectedItemProperty, value); }
        }

        public static readonly DependencyProperty FirstDetailsViewSelectedItemProperty =
            DependencyProperty.Register("FirstDetailsViewSelectedItem", typeof(object), typeof(SelectionBehaviour), new PropertyMetadata(null));
       
        public object FirstNestedCurrentItem
        {
            get { return (object)GetValue(FirstNestedCurrentItemProperty); }
            set { SetValue(FirstNestedCurrentItemProperty, value); }
        }
        public static readonly DependencyProperty FirstNestedCurrentItemProperty =
           DependencyProperty.Register("FirstNestedCurrentItem", typeof(object), typeof(SelectionBehaviour), new PropertyMetadata(null));
        
        public ObservableCollection<object> FirstNestedSelectedItems
        {
            get { return (ObservableCollection<object>)GetValue(FirstNestedSelectedItemsProperty); }
            set { SetValue(FirstNestedSelectedItemsProperty, value); }
        }

        public static readonly DependencyProperty FirstNestedSelectedItemsProperty =
            DependencyProperty.Register("FirstNestedSelectedItems", typeof(ObservableCollection<object>), typeof(SelectionBehaviour), new PropertyMetadata(null));

        protected override void OnAttached()
        {
            base.OnAttached();
            this.AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            (this.AssociatedObject.DetailsViewDefinition[0] as GridViewDefinition).DataGrid.SelectionChanged += FirstDetailsViewDataGridSelectionChanged;
           
            this.AssociatedObject.View.CurrentChanged += View_CurrentChanged;
            
        }
        public Object ViewCurrentItem
        {
            get { return (Object)GetValue(ViewCurrentItemProperty); }
            set { SetValue(ViewCurrentItemProperty, value); }
        }

        public static readonly DependencyProperty ViewCurrentItemProperty =
            DependencyProperty.Register("ViewCurrentItem", typeof(Object), typeof(SelectionBehaviour), new PropertyMetadata(null));

        void View_CurrentChanged(object sender, EventArgs e)
        {
            this.ViewCurrentItem = this.AssociatedObject.View.CurrentItem;
        }
        void FirstDetailsViewDataGridSelectionChanged(object sender, GridSelectionChangedEventArgs e)
        {
            this.FirstDetailsViewSelectedItem = (e.OriginalSender as SfDataGrid).SelectedItem;
            this.FirstNestedSelectedItems = (e.OriginalSender as SfDataGrid).SelectedItems;
            this.FirstNestedCurrentItem = (e.OriginalSender as SfDataGrid).CurrentItem;
       }
    }
}
